package gui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.util.ArrayList;
import java.util.List;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import model.City;
import model.Edge;
import model.Hrany;

public class Graph extends JPanel {

	private static final long serialVersionUID = 1L;
	private Image img;
	private List<Hrany> hrany = new ArrayList<>();
	private List<City> city = new ArrayList<City>();
	public Edge e;
	public Frame f;
	int vzdalenost = 0;
	public Graphics gg;

	public Graph(String img) {
		this.img = new ImageIcon(img).getImage();
		loadCity();
		loadHrany();
		gg = getGraphics();

	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		Graphics2D g2d = (Graphics2D) g.create();
		e = new Edge(g);
		g.drawImage(img, 0, 0, getWidth(), getHeight(), null);

		for (int i = 0; i < city.size(); i++) {
			g2d.setStroke(new BasicStroke(3));
			g2d.setColor(Color.BLACK);
			g2d.drawOval(city.get(i).x - 15, city.get(i).y - 15, 30, 30);

			g.setColor(city.get(i).barva);
			g.fillOval(city.get(i).x - 15, city.get(i).y - 15, 30, 30);

		}

		for (int i = 0; i < hrany.size(); i++) {
			Hrany h = hrany.get(i);

			g2d.setStroke(new BasicStroke(2));
			g2d.setColor(h.barva);
			g2d.drawLine(h.x1, h.y1, h.x2, h.y2);

		}

		e.drawEdge("Plze", "Praha", 100);
		e.drawEdge("Plze", "Usti nad Labem", 150);
		e.drawEdge("Praha", "Hradec Krlov", 110);
		e.drawEdge("Praha", "Liberec", 80);
		e.drawEdge("Liberec", "Hradec Krlov", 100);
		e.drawEdge("Usti nad Labem", "Liberec", 90);
		e.drawEdge("Praha", "Usti nad Labem", 80);
		e.drawEdge("Praha", "Pardubice", 100);
		e.drawEdge("Pardubice", "Hradec Krlov", 30);
		e.drawEdge("Jihlava", "Brno", 90);
		e.drawEdge("Brno", "Olomouc", 75);
		e.drawEdge("Olomouc", "Ostrava", 95);
		e.drawEdge("Praha", "Brno", 205);
		e.drawEdge("Zlin", "Olomouc", 60);
		e.drawEdge("Hradec Krlov", "Olomouc", 150);
		e.drawEdge("Brno", "Zlin", 95);
		e.drawEdge("Usti nad Labem", "Karlovy Vary", 120);
		e.drawEdge("Karlovy Vary", "Plze", 90);
		e.drawEdge("Cheb", "Karlovy Vary", 43);
		e.drawEdge("Cheb", "Plze", 97);
		e.drawEdge("Usti nad Labem", "Dn", 90);
		e.drawEdge("Dn", "Liberec", 70);
		e.drawEdge("Liberec", "Trutnov", 86);
		e.drawEdge("Trutnov", "Hradec Krlov", 50);
		e.drawEdge("Praha", "Mlad Boleslav", 60);
		e.drawEdge("Mlad Boleslav", "Hradec Krlov", 85);
		e.drawEdge("Praha", "Koln", 60);
		e.drawEdge("Koln", "Pardubice", 46);
		e.drawEdge("Plze", "Pbram", 65);
		e.drawEdge("Plze", "Klatovy", 22);
		e.drawEdge("Pbram", "Praha", 60);
		e.drawEdge("Klatovy", "Strakonice", 51);
		e.drawEdge("Strakonice", "esk Krumlov", 72);
		e.drawEdge("esk Krumlov", "esk Budjovice", 26);
		e.drawEdge("Strakonice", "esk Budjovice", 57);
		e.drawEdge("esk Budjovice", "Tbor", 60);
		e.drawEdge("esk Budjovice", "Psek", 50);
		e.drawEdge("Psek", "Praha", 105);
		e.drawEdge("Tbor", "Praha", 87);
		e.drawEdge("Pbram", "Psek", 51);
		e.drawEdge("Tbor", "Jihlava", 110);
		e.drawEdge("esk Budjovice", "Znojmo", 135);
		e.drawEdge("Znojmo", "Jihlava", 51);
		e.drawEdge("Znojmo", "Brno", 67);
		e.drawEdge("Znojmo", "Hodonn", 93);
		e.drawEdge("Hodonn", "Brno", 60);
		e.drawEdge("Hodonn", "Zln", 67);
		e.drawEdge("Zln", "Vsetn", 37);
		e.drawEdge("Vsetn", "Olomouc", 75);
		e.drawEdge("Vsetn", "Ostrava", 73);
		e.drawEdge("Ostrava", "Opava", 35);
		e.drawEdge("Opava", "umperk", 90);
		e.drawEdge("umperk", "Hradec Krlov", 105);
		e.drawEdge("Olomouc", "Opava", 72);
		e.drawEdge("Olomouc", "umperk", 54);
		e.drawEdge("Olomouc", "Svitavy", 70);
		e.drawEdge("Pardubice", "Svitavy", 68);
		e.drawEdge("Liberec", "Mlad Boleslav", 50);
		e.drawEdge("Brno", "Svitavy", 68);
		e.drawEdge("Nchod", "Hradec Krlov", 45);
		e.drawEdge("Nchod", "Trutnov", 34);
		e.drawEdge("Karlovy Vary", "Kladno", 103);
		e.drawEdge("Praha", "Kladno", 27);
		e.drawEdge("esk Budjovice", "Jindichv Hradec", 54);
		e.drawEdge("Jihlava", "Jindichv Hradec", 86);
		e.drawEdge("Tbor", "Jindichv Hradec", 53);
		e.drawEdge("Znojmo", "Jindichv Hradec", 96);
		e.drawEdge("Jihlava", "Havlkv Brod", 26);
		e.drawEdge("Pardubice", "Havlkv Brod", 66);
		e.drawEdge("Koln", "Havlkv Brod", 63);
		e.drawEdge("Brno", "Havlkv Brod", 104);
		e.drawEdge("Svitavy", "Havlkv Brod", 80);
		e.drawEdge("umperk", "Jesenk", 46);
		e.drawEdge("Opava", "Jesenk", 79);
		
		
		
		

	}

	public void loadHrany() {

		hrany.add(new Hrany(165, 445, 415, 325, "Plze", "Praha", 100));
		hrany.add(new Hrany(165, 445, 275, 175, "Plze", "Usti nad Labem", 150));
		hrany.add(new Hrany(415, 325, 665, 245, "Praha", "Hradec Krlov", 110));
		hrany.add(new Hrany(415, 325, 515, 115, "Praha", "Liberec", 80));
		hrany.add(new Hrany(515, 115, 665, 245, "Liberec", "Hradec Krlov",
				100));
		hrany.add(new Hrany(275, 175, 515, 115, "Usti nad Labem", "Liberec", 90));
		hrany.add(new Hrany(415, 325, 275, 175, "Praha", "Usti nad Labem", 80));
		hrany.add(new Hrany(415, 325, 645, 340, "Praha", "Pardubice", 100));
		hrany.add(new Hrany(645, 340, 665, 245, "Pardubice", "Hradec Krlov",
				30));
		hrany.add(new Hrany(620, 530, 790, 610, "Jihlava", "Brno", 90));
		hrany.add(new Hrany(790, 610, 890, 460, "Brno", "Olomouc", 75));
		hrany.add(new Hrany(890, 460, 1080, 400, "Olomouc", "Ostrava", 95));
		hrany.add(new Hrany(415, 325, 790, 610, "Praha", "Brno", 205));
		hrany.add(new Hrany(965, 590, 890, 460, "Zlin", "Olomouc", 60));
		hrany.add(new Hrany(665, 245, 890, 460, "Hradec Krlov", "Olomouc",
				150));
		hrany.add(new Hrany(790, 610, 965, 590, "Brno", "Zlin", 95));
		hrany.add(new Hrany(275, 175, 135, 260, "Usti nad Labem",
				"Karlovy Vary", 120));
		hrany.add(new Hrany(135, 260, 165, 445, "Karlovy Vary", "Plze", 90));
		hrany.add(new Hrany(70, 300, 135, 260, "Cheb", "Karlovy Vary", 43));
		hrany.add(new Hrany(70, 300, 165, 445, "Cheb", "Plze", 97));
		hrany.add(new Hrany(275, 175, 400, 110, "Usti nad Labem", "Dn", 90));
		hrany.add(new Hrany(400, 110, 515, 115, "Dn", "Liberec", 70));
		hrany.add(new Hrany(515, 115, 600, 145, "Liberec", "Trutnov", 86));
		hrany.add(new Hrany(600, 145, 665, 245, "Trutnov", "Hradec Krlov", 50));
		hrany.add(new Hrany(415, 325, 520, 250, "Praha", "Mlad Boleslav", 60));
		hrany.add(new Hrany(520, 250, 665, 245, "Mlad Boleslav",
				"Hradec Krlov", 85));
		hrany.add(new Hrany(415, 325, 540, 370, "Praha", "Koln", 60));
		hrany.add(new Hrany(540, 370, 645, 340, "Koln", "Pardubice", 46));
		hrany.add(new Hrany(165, 445, 340, 430, "Plze", "Pbram", 65));
		hrany.add(new Hrany(165, 445, 180, 530, "Plze", "Klatovy", 22));
		hrany.add(new Hrany(340, 430, 415, 325, "Pbram", "Praha", 60));
		hrany.add(new Hrany(180, 530, 340, 620, "Klatovy", "Strakonice", 51));
		hrany.add(new Hrany(340, 620, 390, 715, "Strakonice", "esk Krumlov",
				72));
		hrany.add(new Hrany(390, 715, 435, 630, "esk Krumlov",
				"esk Budjovice", 26));
		hrany.add(new Hrany(340, 620, 435, 630, "Strakonice",
				"esk Budjovice", 57));
		hrany.add(new Hrany(435, 630, 460, 500, "esk Budjovice", "Tbor", 60));
		hrany.add(new Hrany(435, 630, 370, 520, "esk Budjovice", "Psek", 50));
		hrany.add(new Hrany(370, 520, 415, 325, "Psek", "Praha", 105));
		hrany.add(new Hrany(460, 500, 415, 325, "Tbor", "Praha", 87));
		hrany.add(new Hrany(340, 430, 370, 520, "Pbram", "Psek", 51));
		hrany.add(new Hrany(460, 500, 620, 530, "Tbor", "Jihlava", 110));
		hrany.add(new Hrany(435, 630, 670, 680, "esk Budjovice", "Znojmo",
				135));
		hrany.add(new Hrany(670, 680, 620, 530, "Znojmo", "Jihlava", 51));
		hrany.add(new Hrany(670, 680, 790, 610, "Znojmo", "Brno", 67));
		hrany.add(new Hrany(670, 680, 860, 700, "Znojmo", "Hodonn", 93));
		hrany.add(new Hrany(860, 700, 790, 610, "Hodonn", "Brno", 60));
		hrany.add(new Hrany(860, 700, 965, 590, "Hodonn", "Zln", 67));
		hrany.add(new Hrany(965, 590, 1010, 550, "Zln", "Vsetn", 37));
		hrany.add(new Hrany(1010, 550, 890, 460, "Vsetn", "Olomouc", 75));
		hrany.add(new Hrany(1010, 550, 1080, 400, "Vsetn", "Ostrava", 73));
		hrany.add(new Hrany(1080, 400, 975, 360, "Ostrava", "Opava", 35));
		hrany.add(new Hrany(975, 360, 850, 335, "Opava", "umperk", 90));
		hrany.add(new Hrany(850, 335, 665, 245, "umperk", "Hradec Krlov",
				105));
		hrany.add(new Hrany(890, 460, 975, 360, "Olomouc", "Opava", 72));
		hrany.add(new Hrany(890, 460, 850, 335, "Olomouc", "umperk", 54));
		hrany.add(new Hrany(890, 460, 780, 410, "Olomouc", "Svitavy", 70));
		hrany.add(new Hrany(645, 340, 780, 410, "Pardubice", "Svitavy", 68));
		hrany.add(new Hrany(515, 115, 520, 250, "Liberec", "Mlad Boleslav", 50));
		hrany.add(new Hrany(790, 610, 780, 410, "Brno", "Svitavy", 68));
		hrany.add(new Hrany(675, 190, 665, 245, "Nchod", "Hradec Krlov", 45));
		hrany.add(new Hrany(675, 190, 600, 145, "Nchod", "Trutnov", 34));
		hrany.add(new Hrany(135, 260, 320, 305, "Karlovy Vary", "Kladno", 103));
		hrany.add(new Hrany(415, 325, 320, 305, "Praha", "Kladno", 27));
		hrany.add(new Hrany(435, 630, 525, 595, "esk Budjovice", "Jindichv Hradec", 54));
		hrany.add(new Hrany(620, 530, 525, 595, "Jihlava", "Jindichv Hradec", 86));
		hrany.add(new Hrany(460, 500, 525, 595, "Tbor", "Jindichv Hradec", 53));
		hrany.add(new Hrany(670, 680, 525, 595, "Znojmo", "Jindichv Hradec", 96));
		hrany.add(new Hrany(620, 530, 620, 445, "Jihlava", "Havlkv Brod", 26));
		hrany.add(new Hrany(645, 340, 620, 445, "Pardubice", "Havlkv Brod", 66));
		hrany.add(new Hrany(540, 370, 620, 445, "Koln", "Havlkv Brod", 63));
		hrany.add(new Hrany(790, 610, 620, 445, "Brno", "Havlkv Brod", 104));
		hrany.add(new Hrany(780, 410, 620, 445, "Svitavy", "Havlkv Brod", 80));
		hrany.add(new Hrany(850, 335, 895, 290, "umperk", "Jesenk", 46));
		hrany.add(new Hrany(975, 360, 895, 290, "Opava", "Jesenk", 79));

	
	}

	public void loadCity() {

		city.add(new City(515, 115, "Liberec", Color.YELLOW));
		city.add(new City(165, 445, "Plze", Color.YELLOW));
		city.add(new City(665, 245, "Hradec Krlov", Color.YELLOW));
		city.add(new City(275, 175, "Usti nad Labem", Color.YELLOW));
		city.add(new City(415, 325, "Praha", Color.YELLOW));
		city.add(new City(435, 630, "esk Budjovice", Color.YELLOW));
		city.add(new City(620, 530, "Jihlava", Color.YELLOW));
		city.add(new City(645, 340, "Pardubice", Color.YELLOW));
		city.add(new City(790, 610, "Brno", Color.YELLOW));
		city.add(new City(890, 460, "Olomouc", Color.YELLOW));
		city.add(new City(965, 590, "Zlin", Color.YELLOW));
		city.add(new City(1080, 400, "Ostrava", Color.YELLOW));
		city.add(new City(135, 260, "Karlovy Vary", Color.YELLOW));
		city.add(new City(540, 370, "Koln", Color.YELLOW));
		city.add(new City(520, 250, "Mlad Boleslav", Color.YELLOW));
		city.add(new City(70, 300, "Cheb", Color.YELLOW));
		city.add(new City(460, 500, "Tbor", Color.YELLOW));
		city.add(new City(370, 520, "Psek", Color.YELLOW));
		city.add(new City(670, 680, "Znojmo", Color.YELLOW));
		city.add(new City(780, 410, "Svitavy", Color.YELLOW));
		city.add(new City(600, 145, "Trutnov", Color.YELLOW));
		city.add(new City(340, 430, "Pbram", Color.YELLOW));
		city.add(new City(850, 335, "umperk", Color.YELLOW));
		city.add(new City(975, 360, "Opava", Color.YELLOW));
		city.add(new City(1010, 550, "Vsetn", Color.YELLOW));
		city.add(new City(400, 110, "Dn", Color.YELLOW));
		city.add(new City(180, 530, "Klatovy", Color.YELLOW));
		city.add(new City(860, 700, "Hodonn", Color.YELLOW));
		city.add(new City(390, 715, "esk Krumlov", Color.YELLOW));
		city.add(new City(340, 620, "Strakonice", Color.YELLOW));
		city.add(new City(320, 305, "Kladno", Color.YELLOW));
		city.add(new City(620, 445, "Havlkv Brod", Color.YELLOW));
		city.add(new City(895, 290, "Jesenk", Color.YELLOW));
		city.add(new City(675, 190, "Nchod", Color.YELLOW));
		city.add(new City(525, 595, "Jindichv Hradec", Color.YELLOW));
		
		

	}

	public void vypis(Graphics g, String prvni, String druhy) {

		List<String> listMest = new ArrayList<>();
		for (String entry : e.findPath(prvni, druhy)) {
			listMest.add(entry);
			
		}

		String city, city2;
		Hrany h;
		int j;
		for (int i = 0; i < listMest.size() - 1; i++) {
			city = listMest.get(i);
			city2 = listMest.get(i + 1);
			j = 0;
			h = hrany.get(j++);
			while (!h.isPath(city, city2)) {
				h = hrany.get(j++);

			}

			h.barva = Color.BLUE;
			vzdalenost = vzdalenost + h.weigth;
		}
		String poleMest[] = new String[listMest.size()];
		String trasa = "";
		for (int i = 0; i < listMest.size(); i++) {
			poleMest[i] = listMest.get(i);
			trasa = trasa + poleMest[i] + ", ";
		}
	

		JOptionPane pane = new JOptionPane("Vzdlenost mezi msty " + prvni
				+ " a " + druhy + " je " + vzdalenost + " km" + "\n"
				+ "Trasa cesty je: " + trasa, JOptionPane.INFORMATION_MESSAGE);
		JDialog dialog = pane.createDialog(pane, "Informan okno");
		dialog.setLocation(600, 50);
		dialog.setVisible(true);
		vzdalenost = 0;

	}

	public Edge getE() {
		return e;
	}

	public void setE(Edge e) {
		this.e = e;
	}

	public List<Hrany> getHrany() {
		return hrany;
	}

	public void setHrany(List<Hrany> hrany) {
		this.hrany = hrany;
	}

	public List<City> getCity() {
		return city;
	}

	public void setCity(List<City> city) {
		this.city = city;
	}

}
